//
// StatsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class StatsAPI {
    /**
     Get number of total and active cameras

     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getCameraStats(organizationId: Int? = nil, completion: @escaping ((_ data: StatsCameraGet?,_ error: Error?) -> Void)) {
        getCameraStatsWithRequestBuilder(organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get number of total and active cameras
     - GET /api/v1/stats/cameras
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "total_count" : 0,
  "active_count" : 6
}}]
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<StatsCameraGet> 
     */
    open class func getCameraStatsWithRequestBuilder(organizationId: Int? = nil) -> RequestBuilder<StatsCameraGet> {
        let path = "/api/v1/stats/cameras"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<StatsCameraGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get event intensity in time period captured by stream with provided ID

     - parameter streamId: (query)  
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventIntensityByStreamId(streamId: UUID, tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, organizationId: Int? = nil, completion: @escaping ((_ data: EventIntensityList?,_ error: Error?) -> Void)) {
        getEventIntensityByStreamIdWithRequestBuilder(streamId: streamId, tsFrom: tsFrom, tsTo: tsTo, eventType: eventType, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get event intensity in time period captured by stream with provided ID
     - GET /api/v1/stats/eventsintensity

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "entries" : [ {
    "count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  }, {
    "count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  } ]
}}]
     - parameter streamId: (query)  
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter eventType: (query)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<EventIntensityList> 
     */
    open class func getEventIntensityByStreamIdWithRequestBuilder(streamId: UUID, tsFrom: Date, tsTo: Date, eventType: EventTypeEnum, organizationId: Int? = nil) -> RequestBuilder<EventIntensityList> {
        let path = "/api/v1/stats/eventsintensity"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "stream_id": streamId, 
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON(), 
                        "event_type": eventType, 
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<EventIntensityList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get raw recognition stats in the provided time range

     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventStatsByEventType(tsFrom: Date, tsTo: Date, organizationId: Int? = nil, completion: @escaping ((_ data: [String:[StatsReponseEntry]]?,_ error: Error?) -> Void)) {
        getEventStatsByEventTypeWithRequestBuilder(tsFrom: tsFrom, tsTo: tsTo, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get raw recognition stats in the provided time range
     - GET /api/v1/stats/eventsbytype

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "key" : [ {
    "event_count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  }, {
    "event_count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  } ]
}}]
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<[String:[StatsReponseEntry]]> 
     */
    open class func getEventStatsByEventTypeWithRequestBuilder(tsFrom: Date, tsTo: Date, organizationId: Int? = nil) -> RequestBuilder<[String:[StatsReponseEntry]]> {
        let path = "/api/v1/stats/eventsbytype"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON(), 
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<[String:[StatsReponseEntry]]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get raw recognition stats in the provided time range

     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter organizationId: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getEventStatsByMatchPriority(tsFrom: Date, tsTo: Date, organizationId: Int? = nil, completion: @escaping ((_ data: [String:[StatsReponseEntry]]?,_ error: Error?) -> Void)) {
        getEventStatsByMatchPriorityWithRequestBuilder(tsFrom: tsFrom, tsTo: tsTo, organizationId: organizationId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get raw recognition stats in the provided time range
     - GET /api/v1/stats/eventmatchesbypriority

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "key" : [ {
    "event_count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  }, {
    "event_count" : 0,
    "ts" : "2000-01-23T04:56:07.000+00:00"
  } ]
}}]
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter organizationId: (query)  (optional)

     - returns: RequestBuilder<[String:[StatsReponseEntry]]> 
     */
    open class func getEventStatsByMatchPriorityWithRequestBuilder(tsFrom: Date, tsTo: Date, organizationId: Int? = nil) -> RequestBuilder<[String:[StatsReponseEntry]]> {
        let path = "/api/v1/stats/eventmatchesbypriority"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON(), 
                        "organization_id": organizationId?.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<[String:[StatsReponseEntry]]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
